package pt.moth.instanceTypeAnalysis;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import java.util.Map.Entry;

import soot.Unit;

/**
 * This class allows us to store each result while evaluating each method.
 * A "result" is represented by a given unit (that is a invokeStmt of a interface method)
 * and a set of classes that implement that interface that may be the implementing class  
 *  
 * @author Vasco Pessanha
 *
 */
public class UnitsCollector {
	private static Map<Unit,Set<String>> results = new HashMap<Unit, Set<String>>();
	
	public static void putResult(Unit unit, Set<String> classes) {
		results.put(unit, classes);
	}
	
	public static Set<Entry<Unit, Set<String>>> getResults() {
		return results.entrySet();
	}
	
	public static Set<String> getImplementations(Unit unit) {
		Set<String> r = results.get(unit);
		return r == null? new HashSet<String>():r;
	}
}
