package pt.moth.instanceTypeAnalysis.secondPhase;

import pt.moth.inter.ForwardInterproceduralAnalysis;
import soot.Body;
import soot.SootMethod;
import soot.jimple.InvokeExpr;
import soot.toolkits.graph.BriefUnitGraph;
import soot.toolkits.graph.UnitGraph;

public class InterAnalysis extends ForwardInterproceduralAnalysis<ParamLattice> {
	
	public InterAnalysis() {
		super();
		analyze();
	}
	
	@Override
	protected ParamLattice analyzeMethod(Body activeBody, ParamLattice paramValues) {
		UnitGraph g = new BriefUnitGraph(activeBody);
		ParamLattice res = new IntraAnalysis(g, paramValues, this).getFlowAtEnd();
		return res;
	}

	@Override
	protected void copy(ParamLattice source, ParamLattice dest) {
		source.copy(dest);
	}

	@Override
	protected ParamLattice defaultParameterValues(SootMethod method) {
		return new ParamLattice();
	}

	@Override
	protected ParamLattice defaultReturnValue(SootMethod method) {
		return new ParamLattice();
	}

	@Override
	protected ParamLattice handleSkippedMethodInvocation(SootMethod callerMethod,
			ParamLattice out, InvokeExpr invokeExpr, SootMethod invokedMethod) {
		return (ParamLattice)out.clone();
	}

	@Override
	protected void merge(ParamLattice in1, ParamLattice in2, ParamLattice out) {
		in1.union(in2, out);
	}

	@Override
	protected ParamLattice newInitialFlow() {
		return new ParamLattice();
	}

	@Override
	protected void populateParameters(SootMethod callerMethod,
			SootMethod calleeMethod, InvokeExpr invokeExpr, ParamLattice out,
			ParamLattice parameter) {
		parameter.union(out);
	}

	@Override
	protected boolean shouldAnalyzeMethod(SootMethod method) {
		if (method.getDeclaringClass().isPhantom()) {
			return false;
		}
		else if (!method.hasActiveBody()) {
			return false;
		}
		return true;
	}

}
