package pt.moth.util;

import pt.moth.util.variables.LocalVar;

/**
 * This class represent an ArrayRef
 * In javabyte Code "x = array[0][0]" is translated to:
 * $r0 = int[][] array
 * $r1 = $r0[0]
 * x = $r1[0]
 * 
 * The arrayRefs are the levels of the access:
 * $r0 => (array, 2)
 * $r1 => (array, 1)
 *  x  => (array, 0)
 *  
 * @author Vasco Pessanha
 */
public class ArrayLocal {
	
	protected LocalVar array;
	protected int level;
	
	public ArrayLocal (LocalVar array, int level){
		this.array = array;
		this.level = level;
	}

	public LocalVar getArray() {
		return array;
	}

	public int getLevel() {
		return level;
	}

	public void setLevel(int level) {
		this.level = level;
	}
	public String toString(){
		return array.toString()+ "(level "+level+")";
	}
}
