package pt.moth.util;

import soot.SootClass;

public class ImmutableManager {
	
	/**
	 * Returns if a given class is a Immutable class.
	 * @param className Soot Object that represents a given class
	 * @return true if the class is immutable
	 */
	public static boolean isImmutable(SootClass className){
		String classStr = className.getName();
		return classStr.equals("java.lang.Integer") || 
				classStr.equals("java.lang.Long") ||
				classStr.equals("java.lang.Short") ||
				classStr.equals("java.lang.Character") ||
				classStr.equals("java.lang.String") ||
				classStr.equals("java.lang.Float") ||
				classStr.equals("java.lang.Double") ||
				classStr.equals("java.lang.Byte") ||
				classStr.equals("java.lang.Boolean");
	}
}
