package pt.moth.util.conflicts;

import pt.moth.dependencies.Dep;
import pt.moth.processAnalysis.Process;
import pt.moth.util.View;
import pt.moth.util.variables.GlobalVar;

public class DepConflict extends Conflict implements OneVarConflict{
	
	private Dep dep;
	private View view;
	
	public DepConflict(Process p1, Process p2, Dep dep, View view) {
		this.p1 = p1;
		this.p2 = p2;
		this.dep = dep;
		this.view = view;
		this.type = ConflictType.DEP;
	}
	
	public String toString(){
		return "DepConflict("+dep+","+view.getMethod().getName()+")";
	}

	@Override
	public View getV1() {
		return dep.getFirstView();
	}

	@Override
	public View getV2() {
		return dep.getSecondView();
	}

	@Override
	public View getWriteView() {
		return view;
	}

	@Override
	public GlobalVar getVar() {
		return dep.getDepVariable();
	}
}
