package pt.moth.util.conflicts;

import pt.moth.processAnalysis.Process;
import pt.moth.util.View;
import pt.moth.util.variables.GlobalVar;

/**
 * This class represents a RwW Conflict, i.e., when a Thread reads a given
 * variable and writes a new value according to the first read 
 * 
 * @author Vasco Pessanha
 */
@Deprecated
public class RwWConflict extends Conflict implements OneVarConflict {
	protected View p1Read;
	protected View p1Write;
	protected View p2Write;
	protected GlobalVar v;

	public RwWConflict(Process p1, Process p2, GlobalVar v, View p1Read,
			View p1Write, View p2Write) {
		this.p1 = p1;
		this.p2 = p2;
		this.v = v;
		this.p1Read = p1Read;
		this.p1Write = p1Write;
		this.p2Write = p2Write;
//		this.type = ConflictType.RwW;
	}

	public String toString() {
		String result = "RwWConflict with the variable '"+v+"'\nbetween " + p1.getName() + " and "
				+ p2.getName() + "!!!\nMethod: '" + p2Write.getMethod().getName()
				+ "()'\nVS\nMethods: " + p1Read.getMethod().getName() + "() and "
				+ p1Write.getMethod().getName() + "()";
		return result;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((p1Read == null) ? 0 : p1Read.hashCode());
		result = prime * result + ((p1Write == null) ? 0 : p1Write.hashCode());
		result = prime * result
				+ ((p2Write == null) ? 0 : p2Write.hashCode());
		result = prime * result + ((v == null) ? 0 : v.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		RwWConflict other = (RwWConflict) obj;
		if (p1Read == null) {
			if (other.p1Read != null)
				return false;
		} else if (!p1Read.equals(other.p1Read))
			return false;
		if (p1Write == null) {
			if (other.p1Write != null)
				return false;
		} else if (!p1Write.equals(other.p1Write))
			return false;
		if (p2Write == null) {
			if (other.p2Write != null)
				return false;
		} else if (!p2Write.equals(other.p2Write))
			return false;
		if (v == null) {
			if (other.v != null)
				return false;
		} else if (!v.equals(other.v))
			return false;
		return true;
	}

	@Override
	public View getV1() {
		return p1Read;
	}

	@Override
	public View getV2() {
		return p1Write;
	}

	@Override
	public View getWriteView() {
		return p2Write;
	}

	@Override
	public GlobalVar getVar() {
		return v;
	}
}
