package pt.moth.util.graphs;

public interface IEdge<E> {

	/**
	 * Returns the edge's origin
	 * @return edge's origin
	 */
	public E getOrigin();
	/**
	 * Returns the edge's dest
	 * @return edge's dest
	 */
	public E getDest();
	
	/**
	 * Prints this edge's description
	 */
	public String toString();

	@Override
	public int hashCode();
	@Override
	public boolean equals(Object obj);
	
	/**
	 * Returns a clone of this edge
	 */
	public Edge<E> copy();
}
