package pt.moth.xmlAnnotations;

import soot.SootMethod;

/**
 * This class is a sofisticated String with 2 parts: The class, and the method signature
 * 
 * @author Vasco Pessanha
 */
public class MethodName implements Comparable<MethodName> {
	// Class of the object (toString())
	private String objClass;
	// Method's Signature
	private String methodSignature;
	
	public MethodName(String objString, String methodSignature){
		this.objClass = objString;
		this.methodSignature = methodSignature;
	}
	public MethodName(SootMethod m){
		MethodName aux = getMethodName(m);
		this.objClass = aux.objClass;
		this.methodSignature = aux.methodSignature;
	}
	
	private String trimWhiteSpaces(String x){
		return x.replaceAll(" ", "");
	}
	private MethodName getMethodName(SootMethod m){
		String signature = m.getSignature();
		String objClass = signature.substring(1,signature.indexOf(":"));
		String method = signature.substring(signature.indexOf(":")+2,signature.length()-1);
		method = method.substring(method.indexOf(" ")+1);
		return new MethodName(objClass, trimWhiteSpaces(method));
	}
	
	public String getObjClass() {
		return objClass;
	}

	public void setObjClass(String objClass) {
		this.objClass = objClass;
	}

	public String getMethodSignature() {
		return methodSignature;
	}

	public void setMethodSignature(String methodSignature) {
		this.methodSignature = methodSignature;
	}
	public String toString(){
		return objClass+"->"+methodSignature;
	}

	@Override
	public int compareTo(MethodName o) {
		if(o == null)
			return 1;
		return this.toString().compareTo(o.toString());
	}
}
